diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index e2cd18632f..ab2e5ad308 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -545,6 +545,7 @@ OBJS-$(CONFIG_PBM_ENCODER)             += pnmenc.o
 OBJS-$(CONFIG_PCX_DECODER)             += pcx.o
 OBJS-$(CONFIG_PCX_ENCODER)             += pcxenc.o
 OBJS-$(CONFIG_PFM_DECODER)             += pnmdec.o pnm.o
+OBJS-$(CONFIG_PFM_ENCODER)             += pnmenc.o
 OBJS-$(CONFIG_PGM_DECODER)             += pnmdec.o pnm.o
 OBJS-$(CONFIG_PGM_ENCODER)             += pnmenc.o
 OBJS-$(CONFIG_PGMYUV_DECODER)          += pnmdec.o pnm.o
diff --git a/libavcodec/allcodecs.c b/libavcodec/allcodecs.c
index f00d524747..16ec182a52 100644
--- a/libavcodec/allcodecs.c
+++ b/libavcodec/allcodecs.c
@@ -239,6 +239,7 @@ extern AVCodec ff_pbm_encoder;
 extern AVCodec ff_pbm_decoder;
 extern AVCodec ff_pcx_encoder;
 extern AVCodec ff_pcx_decoder;
+extern AVCodec ff_pfm_encoder;
 extern AVCodec ff_pfm_decoder;
 extern AVCodec ff_pgm_encoder;
 extern AVCodec ff_pgm_decoder;
diff --git a/libavcodec/pnmenc.c b/libavcodec/pnmenc.c
index 7bb42c5a7a..276504bf14 100644
--- a/libavcodec/pnmenc.c
+++ b/libavcodec/pnmenc.c
@@ -19,6 +19,7 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
+#include "libavutil/intreadwrite.h"
 #include "libavutil/imgutils.h"
 #include "libavutil/pixdesc.h"
 #include "avcodec.h"
@@ -77,19 +78,46 @@ static int pnm_encode_frame(AVCodecContext *avctx, AVPacket *pkt,
         n  = avctx->width * 2;
         h1 = (h * 3) / 2;
         break;
+    case AV_PIX_FMT_GBRPF32:
+        c  = 'F';
+        n  = avctx->width * 4;
+        break;
     default:
         return -1;
     }
     snprintf(bytestream, bytestream_end - bytestream,
              "P%c\n%d %d\n", c, avctx->width, h1);
     bytestream += strlen(bytestream);
-    if (avctx->pix_fmt != AV_PIX_FMT_MONOWHITE) {
+    if (avctx->pix_fmt == AV_PIX_FMT_GBRPF32)
+        snprintf(bytestream, bytestream_end - bytestream,
+                 "%f\n", avctx->pix_fmt == AV_PIX_FMT_GBRPF32BE ? 1.f: -1.f);
+    bytestream += strlen(bytestream);
+    if (avctx->pix_fmt != AV_PIX_FMT_MONOWHITE &&
+        avctx->pix_fmt != AV_PIX_FMT_GBRPF32) {
         int maxdepth = (1 << av_pix_fmt_desc_get(avctx->pix_fmt)->comp[0].depth) - 1;
         snprintf(bytestream, bytestream_end - bytestream,
                  "%d\n", maxdepth);
         bytestream += strlen(bytestream);
     }
 
+    if (avctx->pix_fmt == AV_PIX_FMT_GBRPF32) {
+        float *r = (float *)p->data[2];
+        float *g = (float *)p->data[0];
+        float *b = (float *)p->data[1];
+
+        for (int i = 0; i < avctx->height; i++) {
+            for (int j = 0; j < avctx->width; j++) {
+                AV_WN32(bytestream + 0, av_float2int(r[j]));
+                AV_WN32(bytestream + 4, av_float2int(g[j]));
+                AV_WN32(bytestream + 8, av_float2int(b[j]));
+                bytestream += 12;
+            }
+
+            r += p->linesize[2] / 4;
+            g += p->linesize[0] / 4;
+            b += p->linesize[1] / 4;
+        }
+    } else {
     ptr      = p->data[0];
     linesize = p->linesize[0];
     for (i = 0; i < h; i++) {
@@ -97,6 +125,7 @@ static int pnm_encode_frame(AVCodecContext *avctx, AVPacket *pkt,
         bytestream += n;
         ptr        += linesize;
     }
+    }
 
     if (avctx->pix_fmt == AV_PIX_FMT_YUV420P || avctx->pix_fmt == AV_PIX_FMT_YUV420P16BE) {
         h >>= 1;
@@ -189,3 +218,17 @@ AVCodec ff_pbm_encoder = {
     .caps_internal  = FF_CODEC_CAP_INIT_THREADSAFE,
 };
 #endif
+
+#if CONFIG_PFM_ENCODER
+AVCodec ff_pfm_encoder = {
+    .name           = "pfm",
+    .long_name      = NULL_IF_CONFIG_SMALL("PFM (Portable FloatMap) image"),
+    .type           = AVMEDIA_TYPE_VIDEO,
+    .id             = AV_CODEC_ID_PFM,
+    .init           = pnm_encode_init,
+    .encode2        = pnm_encode_frame,
+    .pix_fmts       = (const enum AVPixelFormat[]){ AV_PIX_FMT_GBRPF32,
+                                                    AV_PIX_FMT_NONE },
+    .caps_internal  = FF_CODEC_CAP_INIT_THREADSAFE,
+};
+#endif
diff --git a/libavformat/img2enc.c b/libavformat/img2enc.c
index b303d38239..84201d3beb 100644
--- a/libavformat/img2enc.c
+++ b/libavformat/img2enc.c
@@ -260,7 +260,7 @@ static const AVClass img2mux_class = {
 AVOutputFormat ff_image2_muxer = {
     .name           = "image2",
     .long_name      = NULL_IF_CONFIG_SMALL("image2 sequence"),
-    .extensions     = "bmp,dpx,jls,jpeg,jpg,ljpg,pam,pbm,pcx,pgm,pgmyuv,png,"
+    .extensions     = "bmp,dpx,jls,jpeg,jpg,ljpg,pam,pbm,pcx,pfm,pgm,pgmyuv,png,"
                       "ppm,sgi,tga,tif,tiff,jp2,j2c,j2k,xwd,sun,ras,rs,im1,im8,im24,"
                       "sunras,xbm,xface,pix,y",
     .priv_data_size = sizeof(VideoMuxData),